/****************************************************************************
** Form implementation generated from reading ui file './qsliders.ui'
**
** Created: Tue Jan 22 22:40:47 2002
**      by:  The User Interface Compiler (uic)
**
****************************************************************************/

#include "qsliders.h"
#include <qcheckbox.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlcdnumber.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include <X11/Xlib.h>
#include <X11/extensions/Xvlib.h>


#include <qmessagebox.h>


/* a few global variables... */

  Display *dpy;
  int c;
  char *attr_name = NULL;
//  char *cfg_file = NULL;
  uint num_adaptors = 0;
  XvAdaptorInfo *adaptor_info;
  int n;
//  int load = 0;
  uint adaptor_nr;
  int val = -1111111;
  int port_nr = -1;
  unsigned int xv_version, xv_release;
  unsigned int xv_request_base, xv_event_base, xv_error_base;
  char temps[80];





int getset()
{
    Atom attr_atom;
    int wynik=0;
    attr_atom = XInternAtom(dpy, attr_name, False);



    if(port_nr == -1) {
      if(num_adaptors == 0) {
        fprintf(stderr, "No adaptor\n");
        exit(-1);
      }
      port_nr = adaptor_info[adaptor_nr].base_id;
    }
    if(val == -1111111) {
      if(XvGetPortAttribute(dpy, port_nr, attr_atom, &val) != Success) {
//        fprintf(stderr, "Couldn't get attribute\n");
        exit(-1);
      }
      fprintf(stdout,"%s = %d\n", attr_name, val);
    } else {
      if(XvSetPortAttribute(dpy, port_nr, attr_atom, val) != Success) {
//        fprintf(stderr, "Couldn't set attribute\n");
        exit(-1);
      }
      XFlush(dpy);
      if(XvGetPortAttribute(dpy, port_nr, attr_atom, &val) != Success) {
//       fprintf(stderr, "Couldn't get attribute\n");
     wynik=1;
//      exit(-1);
  }
      fprintf(stdout,"%s set to %d\n", attr_name, val);
    }

return wynik;
}





/* 
 *  Constructs a qsliders which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
qsliders::qsliders( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{



    if ( !name )
	setName( "qsliders" );
    resize( 363, 241 );
    setMinimumSize(363,241);
    setMaximumSize(363,241);
    setCaption( tr( "XV setting" ) );

    TextLabel5 = new QLabel( this, "TextLabel5" );
    TextLabel5->setGeometry( QRect( 10, 130, 190, 20 ) );
    QFont TextLabel5_font(  TextLabel5->font() );
    TextLabel5_font.setBold( TRUE );
    TextLabel5_font.setPointSize( 10 );
    TextLabel5->setFont( TextLabel5_font ); 
    TextLabel5->setText( tr( "DOUBLE BUFFER     NOT AVAILABLE" ) );

    TextLabel4 = new QLabel( this, "TextLabel4" );
    TextLabel4->setGeometry( QRect( 10, 100, 190, 20 ) );
    QFont TextLabel4_font(  TextLabel4->font() );
    TextLabel4_font.setBold( TRUE );
    TextLabel4_font.setPointSize( 10 );
    TextLabel4->setFont( TextLabel4_font ); 
    TextLabel4->setText( tr( "HUE                          NOT AVAILABLE" ) );

    TextLabel3 = new QLabel( this, "TextLabel3" );
    TextLabel3->setGeometry( QRect( 10, 70, 190, 20 ) );
    QFont TextLabel3_font(  TextLabel3->font() );
    TextLabel3_font.setBold( TRUE );
    TextLabel3_font.setPointSize( 10 );
    TextLabel3->setFont( TextLabel3_font ); 
    TextLabel3->setText( tr( "SATURATION         NOT AVAILABLE" ) );

    TextLabel2 = new QLabel( this, "TextLabel2" );
    TextLabel2->setGeometry( QRect( 10, 40, 190, 20 ) );
    QFont TextLabel2_font(  TextLabel2->font() );
    TextLabel2_font.setBold( TRUE );
    TextLabel2_font.setPointSize( 10 );
    TextLabel2->setFont( TextLabel2_font ); 
    TextLabel2->setText( tr( "CONTRAST            NOT AVAILABLE" ) );

    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setGeometry( QRect( 10, 10, 190, 20 ) );
    QFont TextLabel1_font(  TextLabel1->font() );
    TextLabel1_font.setBold( TRUE );
    TextLabel1_font.setPointSize( 10 );
    TextLabel1->setFont( TextLabel1_font ); 
    TextLabel1->setText( tr( "BRIGHTNESS          NOT AVAILABLE" ) );

    LCDNumber1 = new QLCDNumber( this, "LCDNumber1" );
    LCDNumber1->setGeometry( QRect( 290, 10, 60, 20 ) ); 
    QPalette pal;
    QColorGroup cg;
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 212, 0, 159) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    LCDNumber1->setPalette( pal );
    LCDNumber1->setFrameShape( QLCDNumber::NoFrame );
    LCDNumber1->setProperty( "intValue", -1 );

    LCDNumber2 = new QLCDNumber( this, "LCDNumber2" );
    LCDNumber2->setGeometry( QRect( 290, 40, 61, 21 ) ); 
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 212, 0, 159) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    LCDNumber2->setPalette( pal );
    LCDNumber2->setFrameShape( QLCDNumber::NoFrame );
    LCDNumber2->setProperty( "intValue", -1 );

    LCDNumber3 = new QLCDNumber( this, "LCDNumber3" );
    LCDNumber3->setGeometry( QRect( 290, 70, 61, 21 ) ); 
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 212, 0, 159) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    LCDNumber3->setPalette( pal );
    LCDNumber3->setFrameShape( QLCDNumber::NoFrame );
    LCDNumber3->setProperty( "intValue", -1 );

    LCDNumber4 = new QLCDNumber( this, "LCDNumber4" );
    LCDNumber4->setGeometry( QRect( 290, 100, 60, 20 ) ); 
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 212, 0, 159) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    LCDNumber4->setPalette( pal );
    LCDNumber4->setFrameShape( QLCDNumber::NoFrame );
    LCDNumber4->setProperty( "intValue", -1 );

    LCDNumber5 = new QLCDNumber( this, "LCDNumber5" );
    LCDNumber5->setGeometry( QRect( 290, 130, 61, 21 ) ); 
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 212, 0, 159) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 170, 0, 127) );
    cg.setColor( QColorGroup::Light, QColor( 255, 0, 191) );
    cg.setColor( QColorGroup::Midlight, QColor( 195, 0, 146) );
    cg.setColor( QColorGroup::Dark, QColor( 85, 0, 64) );
    cg.setColor( QColorGroup::Mid, QColor( 113, 0, 85) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    LCDNumber5->setPalette( pal );
    LCDNumber5->setFrameShape( QLCDNumber::NoFrame );
    LCDNumber5->setProperty( "intValue", -1 );

    co = new QSlider( this, "co" );
    co->setGeometry( QRect( 110, 40, 161, 21 ) ); 
    co->setOrientation( QSlider::Horizontal );
    co->setMaxValue(0);
    co->setMinValue(-1);
    co->setValue(-1);
    co->hide();

    sa = new QSlider( this, "sa" );
    sa->setGeometry( QRect( 110, 70, 161, 21 ) ); 
    sa->setOrientation( QSlider::Horizontal );
    sa->setMaxValue(0);
    sa->setMinValue(-1);
    sa->setValue(-1);
    sa->hide();


    hu = new QSlider( this, "hu" );
    hu->setGeometry( QRect( 110, 100, 161, 21 ) ); 
    hu->setOrientation( QSlider::Horizontal );
    hu->setMaxValue(0);
    hu->setMinValue(-1);
    hu->setValue(-1);
    hu->hide();

    br = new QSlider( this, "br" );
    br->setGeometry( QRect( 110, 10, 161, 21 ) ); 
    br->setOrientation( QSlider::Horizontal );
    br->setMaxValue(0);
    br->setMinValue(-1);
    br->setValue(-1);
    br->hide();

    PushButton1 = new QPushButton( this, "PushButton1" );
    PushButton1->setGeometry( QRect( 10, 210, 61, 21 ) ); 
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 233, 233, 233) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 0, 85, 0) );
    cg.setColor( QColorGroup::ButtonText, QColor( 0, 85, 0) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 0, 85, 0) );
    cg.setColor( QColorGroup::ButtonText, QColor( 0, 85, 0) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 0, 85, 0) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    PushButton1->setPalette( pal );
    QFont PushButton1_font(  PushButton1->font() );
    PushButton1_font.setBold( TRUE );
    PushButton1_font.setPointSize( 10 );
    PushButton1->setFont( PushButton1_font ); 
    PushButton1->setText( tr( "LOAD" ) );

    PushButton3 = new QPushButton( this, "PushButton3" );
    PushButton3->setGeometry( QRect( 130, 210, 100, 21 ) ); 
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 233, 233, 233) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 0, 0, 127) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 0, 0, 127) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    PushButton3->setPalette( pal );
    QFont PushButton3_font(  PushButton3->font() );
    PushButton3_font.setBold( TRUE );
    PushButton3_font.setPointSize( 10 );
    PushButton3->setFont( PushButton3_font ); 
    PushButton3->setText( tr( "SET DEFAULTS" ) );

    PushButton2 = new QPushButton( this, "PushButton2" );
    PushButton2->setGeometry( QRect( 290, 210, 61, 21 ) ); 
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 233, 233, 233) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 255, 0, 0) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 255, 0, 0) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 90, 36, 0) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    PushButton2->setPalette( pal );
    QFont PushButton2_font(  PushButton2->font() );
    PushButton2_font.setBold( TRUE );
    PushButton2_font.setPointSize( 10 );
    PushButton2->setFont( PushButton2_font ); 
    PushButton2->setText( tr( "SAVE" ) );

    Line1 = new QFrame( this, "Line1" );
    Line1->setGeometry( QRect( 10, 190, 340, 20 ) ); 
    Line1->setFrameStyle( QFrame::HLine | QFrame::Sunken );

    PushButton10 = new QPushButton( this, "PushButton10" );
    PushButton10->setGeometry( QRect( 290, 170, 61, 21 ) ); 
    QFont PushButton10_font(  PushButton10->font() );
    PushButton10_font.setPointSize( 10 );
    PushButton10->setFont( PushButton10_font );
    PushButton10->setText( tr( "About" ) );

    db = new QSlider( this, "db" );
    db->setGeometry( QRect( 110, 130, 161, 21 ) );
    db->setMinValue( -1 );
    db->setMaxValue( 0 );
    db->setPageStep( 1 );
    db->setOrientation( QSlider::Horizontal );
    db->hide();
    db->setValue(-1);

    Line7 = new QFrame( this, "Line7" );
    Line7->setGeometry( QRect( 10, 150, 341, 20 ) ); 
    Line7->setFrameStyle( QFrame::HLine | QFrame::Sunken );

    ac = new QCheckBox( this, "ac" );
    ac->setGeometry( QRect( 10, 170, 80, 20 ) );
    QFont ac_font(  ac->font() );
    ac_font.setPointSize( 10 );
    ac->setFont( ac_font );

    ac->setText( tr( "auto center" ) );

    // signals and slots connections
    connect( br, SIGNAL( valueChanged(int) ), LCDNumber1, SLOT( display(int) ) );
    connect( co, SIGNAL( valueChanged(int) ), LCDNumber2, SLOT( display(int) ) );
    connect( sa, SIGNAL( valueChanged(int) ), LCDNumber3, SLOT( display(int) ) );
    connect( hu, SIGNAL( valueChanged(int) ), LCDNumber4, SLOT( display(int) ) );
    connect( db, SIGNAL( valueChanged(int) ), LCDNumber5, SLOT( display(int) ) );
    connect( br, SIGNAL( valueChanged(int) ), this, SLOT( on_br() ) );
    connect( co, SIGNAL( valueChanged(int) ), this, SLOT( on_co() ) );
    connect( sa, SIGNAL( valueChanged(int) ), this, SLOT( on_sa() ) );
    connect( hu, SIGNAL( valueChanged(int) ), this, SLOT( on_hu() ) );
    connect( db, SIGNAL( valueChanged(int) ), this, SLOT( on_db() ) );
    connect( ac, SIGNAL( stateChanged(int) ), this, SLOT( on_autocenter() ) );
    connect( PushButton10, SIGNAL( released() ), this, SLOT( on_about() ) );
    connect( PushButton1, SIGNAL( released() ), this, SLOT( on_load() ) );
    connect( PushButton3, SIGNAL( released() ), this, SLOT( on_defaults() ) );
    connect( PushButton2, SIGNAL( released() ), this, SLOT( on_save() ) );



  dpy = XOpenDisplay(NULL);
  if(dpy == NULL) {
    fprintf(stderr, "Couldn't open display\n");
    exit(-1);
  }

/* POPRAW */

  adaptor_nr=0;

  if(XvQueryExtension(dpy, &xv_version, &xv_release, &xv_request_base,
                      &xv_event_base, &xv_error_base) == Success) {
    fprintf(stdout, "Found Xv %d.%d\n", xv_version, xv_release);
  } else {
    fprintf(stderr, "Xv not found\n");
    exit(-1);
  }

  XvQueryAdaptors(dpy, DefaultRootWindow(dpy),&num_adaptors, &adaptor_info);


  if (adaptor_nr>num_adaptors)
{
    fprintf(stderr, "Adaptor %d not found\n",adaptor);
    exit(-1);
  }



  sprintf(temps,"XV setting - %s",adaptor_info[0].name);

  setCaption( tr( temps ) );

/* numer adaptora */
      int n=0;
      int base_id;
      int num_ports;
      int m;
      base_id = adaptor_info[n].base_id;
      num_ports = adaptor_info[n].num_ports;

      fprintf(stdout, "Adaptor: %d\n", n);
      fprintf(stdout, "Name: %s\n", adaptor_info[n].name);

/* BEGIN for */
      for(m = base_id; m < base_id+num_ports; m++) {
        int num;
        int k;
        int cur_val;
        Atom val_atom;
        XvAttribute *xvattr;

        fprintf(stdout, " Port: %d\n", m);
        xvattr = XvQueryPortAttributes(dpy, m, &num);
        for(k = 0; k < num; k++) {
          fprintf(stdout, "  Name: %s\n", xvattr[k].name);
          fprintf(stdout, "   Flags: %s%s\n",
                  (xvattr[k].flags & XvGettable) ? "XvGettable " : "",
                  (xvattr[k].flags & XvSettable) ? "XvSettable " : "");
          fprintf(stdout, "   Min value: %d\n", xvattr[k].min_value);
          fprintf(stdout, "   Max value: %d\n", xvattr[k].max_value);
          val_atom = XInternAtom(dpy, xvattr[k].name, False);
          if(xvattr[k].flags & XvGettable) {
            if(XvGetPortAttribute(dpy, m, val_atom, &cur_val) != Success) {
              fprintf(stderr, "Couldn't get attribute\n");
              exit(-1);
    }
            fprintf(stdout, "   Current value: %d\n", cur_val);
     /* ustaw slidery */
       QSlider *cel=NULL;
       QLabel *celtxt=NULL;
       if (strstr(xvattr[k].name,"XV_BRIGHTNESS"))
         {
					cel=br;
    				celtxt=TextLabel1;
					}
       if (strstr(xvattr[k].name,"XV_CONTRAST"))
         {
					cel=co;
    				celtxt=TextLabel2;
					}
       if (strstr(xvattr[k].name,"XV_SATURATION"))
         {
					cel=sa;
					celtxt=TextLabel3;
					}
       if (strstr(xvattr[k].name,"XV_HUE"))
         {
					cel=hu;
					celtxt=TextLabel4;
					}
       if (strstr(xvattr[k].name,"XV_DOUBLE_BUFFER"))
         {
					cel=db;
					celtxt=TextLabel5;
					}



		   if (cel)
        {
         cel->setMaxValue(xvattr[k].max_value);
         cel->setMinValue(xvattr[k].min_value);
         cel->setValue(cur_val);
         cel->show();
         char *f;
         f=strstr(xvattr[k].name,"XV_");
         if (f!=NULL) f=xvattr[k].name+3;
         celtxt->setText( tr( f ) );


         }

     /* END ustaw_slidery */
          }
        }
      }

/* END for */



}





/*
 *  Destroys the object and frees any allocated resources
 */
qsliders::~qsliders()
{
    // no need to delete child widgets, Qt does it all for us
}

/*  
 *  Main event handler. Reimplemented to handle application
 *  font changes
 */
bool qsliders::event( QEvent* ev )
{
    bool ret = QDialog::event( ev ); 
    if ( ev->type() == QEvent::ApplicationFontChange ) {
	QFont TextLabel5_font(  TextLabel5->font() );
	TextLabel5_font.setBold( TRUE );
	TextLabel5->setFont( TextLabel5_font ); 
	QFont TextLabel4_font(  TextLabel4->font() );
	TextLabel4_font.setBold( TRUE );
	TextLabel4->setFont( TextLabel4_font ); 
	QFont TextLabel3_font(  TextLabel3->font() );
	TextLabel3_font.setBold( TRUE );
	TextLabel3->setFont( TextLabel3_font ); 
	QFont TextLabel2_font(  TextLabel2->font() );
	TextLabel2_font.setBold( TRUE );
	TextLabel2->setFont( TextLabel2_font ); 
	QFont TextLabel1_font(  TextLabel1->font() );
	TextLabel1_font.setBold( TRUE );
	TextLabel1->setFont( TextLabel1_font ); 
	QFont PushButton1_font(  PushButton1->font() );
	PushButton1_font.setBold( TRUE );
	PushButton1->setFont( PushButton1_font ); 
	QFont PushButton3_font(  PushButton3->font() );
	PushButton3_font.setBold( TRUE );
	PushButton3->setFont( PushButton3_font ); 
	QFont PushButton2_font(  PushButton2->font() );
	PushButton2_font.setBold( TRUE );
	PushButton2->setFont( PushButton2_font ); 
    }


    return ret;
}

void qsliders::on_about()
{
 QMessageBox::about( this, "XV attribute setting",
                        "gxvattr (C) 2002 Piotr Wiejak\n"
						"With this small GUI you can adjust XV attributes,\n"
						"save and restore settings (even without GUI).\n"
                        "For more details RTFM [if exists ;-)))]." );

}

void qsliders::on_autocenter()
{
    qsliders::on_br();
    qsliders::on_co();
    qsliders::on_sa();
}

void qsliders::on_br()
{
 QSlider *tmp=br;
 int zakres=((tmp->maxValue()-tmp->minValue())/30);
 int srodek=(tmp->maxValue()+tmp->minValue())/2;
 int min=srodek-zakres;
 int max=srodek+zakres;

if (ac->isChecked())
 if (tmp->value()<max)
   if (tmp->value()>min)
       tmp->setValue(srodek);


 strcpy(temps,"XV_BRIGHTNESS");
 attr_name=temps;
 val=br->value();
 getset();
}

void qsliders::on_co()
{

 QSlider *tmp=co;
 int zakres=((tmp->maxValue()-tmp->minValue())/30);
 int srodek=(tmp->maxValue()+tmp->minValue())/2;
 int min=srodek-zakres;
 int max=srodek+zakres;

if (ac->isChecked())
 if (tmp->value()<max)
   if (tmp->value()>min)
       tmp->setValue(srodek);


 strcpy(temps,"XV_CONTRAST");
 attr_name=temps;
 val=co->value();
 getset();

}

void qsliders::on_db()
{
 strcpy(temps,"XV_DOUBLE_BUFFER");
 attr_name=temps;
 val=db->value();
 getset();

}

void qsliders::on_defaults()
{
 strcpy(temps,"XV_SET_DEFAULTS");
 attr_name=temps;
 val=0;
 getset();
/* numer adaptora */
      int n=0;
      int base_id;
      int num_ports;
      int m;
      base_id = adaptor_info[n].base_id;
      num_ports = adaptor_info[n].num_ports;

      fprintf(stdout, "Adaptor: %d\n", n);
      fprintf(stdout, "Name: %s\n", adaptor_info[n].name);

/* BEGIN for */
      for(m = base_id; m < base_id+num_ports; m++) {
        int num;
        int k;
        int cur_val;
        Atom val_atom;
        XvAttribute *xvattr;

        fprintf(stdout, " Port: %d\n", m);
        xvattr = XvQueryPortAttributes(dpy, m, &num);
        for(k = 0; k < num; k++) {
          fprintf(stdout, "  Name: %s\n", xvattr[k].name);
          fprintf(stdout, "   Flags: %s%s\n",
                  (xvattr[k].flags & XvGettable) ? "XvGettable " : "",
                  (xvattr[k].flags & XvSettable) ? "XvSettable " : "");
          fprintf(stdout, "   Min value: %d\n", xvattr[k].min_value);
          fprintf(stdout, "   Max value: %d\n", xvattr[k].max_value);
          val_atom = XInternAtom(dpy, xvattr[k].name, False);
          if(xvattr[k].flags & XvGettable) {
            if(XvGetPortAttribute(dpy, m, val_atom, &cur_val) != Success) {
              fprintf(stderr, "Couldn't get attribute\n");
              exit(-1);
    }
            fprintf(stdout, "   Current value: %d\n", cur_val);
     /* ustaw slidery */
       QSlider *cel=NULL;
       if (strstr(xvattr[k].name,"XV_BRIGHTNESS"))
         {
					cel=br;
					}
       if (strstr(xvattr[k].name,"XV_CONTRAST"))
         {
					cel=co;
					}
       if (strstr(xvattr[k].name,"XV_SATURATION"))
         {
					cel=sa;
					}
       if (strstr(xvattr[k].name,"XV_HUE"))
         {
					cel=hu;
					}
       if (strstr(xvattr[k].name,"XV_DOUBLE_BUFFER"))
         {
					cel=db;
					}



		   if (cel)
        {
         cel->setMaxValue(xvattr[k].max_value);
         cel->setMinValue(xvattr[k].min_value);
         cel->setValue(cur_val);

         }

     /* END ustaw_slidery */
          }
        }
      }

/* END for */



}

void qsliders::on_hu()
{
 strcpy(temps,"XV_HUE");
 attr_name=temps;
 val=hu->value();
 getset();

}

void qsliders::on_load()
{
 FILE *cfg;
  char *cfg_file = NULL;
  char line[80];
  char cfg_name[128]="/usr/local/etc/xvattr.conf";
  char *atr,*value;

  if (cfg_file==NULL)
   {
    cfg_file=cfg_name;
   }

  if ((cfg=fopen(cfg_file,"r"))==NULL)
    {
     printf("Error opening file %s!\n",cfg_file);
     exit(1);
    }

    while( (fgets(line,128,cfg))!=NULL)
    {
    if (strlen(line)>4)
      /* Don't read comments */
     if (line[0]!='#')
     {
      atr=strstr(line,"=");
      /* If the line seems to be correct (contains '=') */
      if (atr!=NULL)
       {
       *(atr)='\0';
       attr_name=line;
       value=atr+1;
       val=atoi(value);
       /* Apply values (and print it for debugging purposes */
       printf("Setting %s = %i -> ",attr_name,val);
       QSlider *cel=NULL;
       if (strstr(attr_name,"XV_BRIGHTNESS"))
         {
					cel=br;
					}
       if (strstr(attr_name,"XV_CONTRAST"))
         {
					cel=co;
					}
       if (strstr(attr_name,"XV_SATURATION"))
         {
					cel=sa;
					}
       if (strstr(attr_name,"XV_HUE"))
         {
					cel=hu;
					}
       if (strstr(attr_name,"XV_DOUBLE_BUFFER"))
         {
					cel=db;
					}



		   if (cel)
        {
         cel->setValue(val);

         }


       }
     }
    }

  fclose(cfg);

}

void qsliders::on_sa()
{
 QSlider *tmp=sa;
 int zakres=((tmp->maxValue()-tmp->minValue())/30);
 int srodek=(tmp->maxValue()+tmp->minValue())/2;
 int min=srodek-zakres;
 int max=srodek+zakres;

if (ac->isChecked())
 if (tmp->value()<max)
   if (tmp->value()>min)
       tmp->setValue(srodek);


 strcpy(temps,"XV_SATURATION");
 attr_name=temps;
 val=sa->value();
 getset();

}

void qsliders::on_save()
{
 FILE *cfg;
  char *cfg_file = NULL;
  char cfg_name[128]="/usr/local/etc/xvattr.conf";

  if (cfg_file==NULL)
   {
    cfg_file=cfg_name;
   }

  if ((cfg=fopen(cfg_file,"w"))==NULL)
    {
     printf("Error opening file %s!\n",cfg_file);
     exit(1);
    }

if (br->value()!=-1) fprintf(cfg,"XV_BRIGHTNESS=%d\n",br->value());
if (co->value()!=-1)fprintf(cfg,"XV_CONTRAST=%d\n",co->value());
if (sa->value()!=-1)fprintf(cfg,"XV_SATURATION=%d\n",sa->value());
if (hu->value()!=-1)fprintf(cfg,"XV_HUE=%d\n",hu->value());
if (db->value()!=-1)fprintf(cfg,"XV_DOUBLE_BUFFER=%d\n",db->value());


fclose(cfg);
}



